library GETstatus;

uses
  SysUtils,
  Graphics,
  Windows,
  Registry,
  StrUtils,
  Dialogs,
  Messages,
  winsock,
  dmMainUnit in 'dmMainUnit.pas' {dmMain: TDataModule},
  frmMainUnit in 'frmMainUnit.pas' {frmMain},
  PluginUnit in 'PluginUnit.pas';

const
  PLUGIN_NAME = 'LogCenter';
  PLUG_PLAYSTAT = 1;
  REG_PATH_1 = 'Software\MyPortal\Akuku\';
  REG_PATH_2 = '\Ustawienia';
  GLOBAL_PATH = 'Software\MyPortal\Akuku';
  PLUGIN_UNLOAD = 0;


{$R *.res}

var
  LastExecution: TDateTime;
  myString  : AnsiString;
  PluginSetNote: TPluginSetNote;

procedure DoPluginTimer; register;

var
  Registry: TRegistry;
  odebrane : integer;
  RemoteAddress : TSockAddr;
  point: TWSAData;
  Socket: TSocket;
  bufor: AnsiString;
  error,status: integer;
  li      : TLinger;

begin

if LastExecution <> Now then
begin
  myString:='';
  Winsock.WSAStartup($0101, point);
  with RemoteAddress do begin
    Sin_Family:=PF_INET;
    Sin_Port:=Winsock.htons(7777);
    Sin_addr:=TInAddr(Pointer((gethostbyname('192.168.2.10'))^.h_addr_list^)^);
    end;
    Socket:=Winsock.socket(PF_INET, SOCK_STREAM, IPPROTO_IP);
    // Now make sure "linger" is turned ON.
    li.l_onoff  := 1;              { enable linger  }
    li.l_linger := 0;             { 15 sec timeout }
    Status := SetSockOpt(Socket, SOL_SOCKET, SO_LINGER, @li,SizeOf(li));

    error:= Winsock.Connect(Socket,RemoteAddress,SizeOf(RemoteAddress));
    odebrane := 0;
    if(error=0) then
      begin
      SetLength(bufor,256);
      odebrane := Winsock.recv(socket,bufor[1],6,0);
      Winsock.shutdown(socket,0);
      Winsock.CloseSocket(Socket);
      end;

    //WSASendDisconnect();
    //WSACleanup();
    //Winsock.shutdown(socket,0);

    @PluginSetNote := GetProcAddress(dmMain.AppHandle, 'PluginSetNote');
    if Assigned(@PluginSetNote) then
      if ( (odebrane>=4) and (odebrane<=8) ) then
        begin
        bufor := 'Za oknem ' + bufor + ' [' + FormatDateTime('hh:mm', (Time)) + ']';
        PluginSetNote(bufor);
        end
      else PluginSetNote('');
    LastExecution := Now;
end;

end;

function GetPluginTimer: Integer; register;
begin
  Result := 1000;
end;

function GetPluginTimerByName(Index: Integer): Integer; register;
begin
  case Index of
    PLUG_PLAYSTAT : Result := 60000; //60s
  else
    Result := 0;
  end;
end;

function GetPluginName(Index: Integer): ShortString; register;
begin
  case Index of
    PLUG_PLAYSTAT  : Result := PLUGIN_NAME;
  else
    Result := '';
  end;
end;

function GetPluginIcon(var PluginIcon: TIcon; Index: Integer): Boolean; register;
begin

Result := True;

if Assigned(dmMain) then
  begin
    case Index of
      PLUG_PLAYSTAT : dmMain.ilIkony.GetIcon(0, PluginIcon);
    else
      Result := False;
    end;
  end;

end;

procedure AliveExt(Instance: THandle; AQQNumber: Integer; AppPath, SkinPath: ShortString); register;
begin

if not Assigned(dmMain)  then dmMain := TdmMain.Create(nil);
dmMain.AQQNumber := AQQNumber;
dmMain.AppPath := AppPath;
dmMain.SkinPath := SkinPath;
dmMain.AppHandle := Instance;

dmMain.REG_PATH := REG_PATH_1 + IntToStr(AQQNumber) + REG_PATH_2;

end;

procedure Init(Command: ShortString; Index: Integer); register;
begin

case Index of
  PLUG_PLAYSTAT:
    begin
      try
        if not Assigned(frmMain) then
          begin
            frmMain := TfrmMain.Create(nil);
          end;

        frmMain.ShowModal;
      finally
        FreeAndNil(frmMain);
      end;
    end;
end;

end;


procedure Unload(Index: Integer); register;
begin

case Index of
  PLUGIN_UNLOAD, PLUG_PLAYSTAT:
    begin
      dmMain.SystemShutDown := True;

      if Assigned(frmMain) then
        begin
          frmMain.Close;
        end;

      dmMain.SystemShutDown := False;
    end;
end;

end;

exports
  GetPluginTimerByName, GetPluginTimer, DoPluginTimer, GetPluginIcon, GetPluginName, AliveExt, Init, UnLoad;

begin
end.


