unit PluginUnit;

interface

uses
  Graphics;

//------------------------------------------------------------------------------
// Pozostae deklaracje
//------------------------------------------------------------------------------

const
  ONLINE       = 'ONLINE';
  FREEFORCHAT  = 'FREEFORCHAT';
  AWAY         = 'AWAY';
  NA           = 'NA';
  OCCUPIED     = 'OCUPPIED';
  DND          = 'DND';
  INVISIBLE    = 'INVISIBLE';
  UNKNOWN      = 'UNKNOWN';
  OFFLINE      = 'OFFLINE';

const
  SIMPLE_SEARCH = 1;

type
  TNetPlugin = packed record
    Name       : ShortString; // Nazwa pluginu
    Network    : ShortString; // Nazwa sieci -> WP Kontakt, Tlen
    Author     : ShortString; // Autor pluginu
    Version    : ShortString; // Wersja pluginu
    AQQVersion : ShortString; // Minimalna wymagana wersja AQQ
    UID        : ShortString; // Nazwa UIDu -> WPK
    IDText     : Boolean;     // Czy ID usera jest tekstowe?
    ServerMode : Boolean;     // Czy lista kontaktw jest na serwerze? (tryb usuwania)
  end;

type
  TNetStatePlugin = packed record
    Name   : ShortString;     // Nazwa stanu -> Poczony
    UID    : ShortString;     // UID stanu -> ONLINE
    CallID : Integer;         // CallID -> ID wywoawcze
    Icon   : TIcon;           // Ikonka stanu
    Position : Integer;       // Pozycja w ImageLicie <- parametr ustawiany po stronie app
  end;

type
  TNetStatePluginArray = array of TNetStatePlugin;

//------------------------------------------------------------------------------
// Deklaracje funkcji i procedur zdalnych
//------------------------------------------------------------------------------

type
  TNetPluginInit        = function(Instance: THandle): Boolean; stdcall;
  TNetPluginInfo        = function: TNetPlugin; stdcall;
  TNetPluginStates      = function: TNetStatePluginArray; stdcall;
  TNetPluginSendMessage = procedure(Login: ShortString; Tekst: String); stdcall;

//------------------------------------------------------------------------------
// Zdarzenia
//------------------------------------------------------------------------------

type
  TOnConnect    = procedure(UID: ShortString) stdcall;
  TOnConnecting = procedure(UID: ShortString) stdcall;
  TOnDisconnect = procedure(UID: ShortString) stdcall;
  TOnBadLogin   = procedure(UID: ShortString) stdcall;
  TOnMyState    = procedure(UID: ShortString; CallID: Integer); stdcall;
  TOnNotFound   = procedure(UID, Login: ShortString); stdcall;
  TOnMessage    = procedure(UID, From: ShortString; Tekst: String; Stamp: TDateTime); stdcall;
  TOnNewContact = procedure(UID, Login: ShortString); stdcall;
  TOnDeleteContact = procedure(UID, Login: ShortString); stdcall;
  TOnUserState  = procedure(UID, Login, Status: ShortString; CallID: Integer); stdcall;

//------------------------------------------------------------------------------
// Wywoanie
//------------------------------------------------------------------------------

type
  TDisconnect = procedure(UID: ShortString);
  TState = procedure(UID: ShortString; CallID: Integer);
  TLogin = procedure(UID, Login, Pass, CustomServer: ShortString; CustomPort, CallID: Integer); register;

  TSimpleSearch = procedure(Login, UID: ShortString); stdcall;
  TGetSearchIcon = function(UID: ShortString): TIcon; stdcall;
  TGetGreyIcon = function(UID: ShortString): TIcon; stdcall;
  TGetUnknownIcon = function(UID: ShortString): TIcon; stdcall;
  TSetBestImages = procedure; stdcall;
  TDeleteUser = procedure(Login, UID: ShortString); stdcall;

//------------------------------------------------------------------------------
// Register
//------------------------------------------------------------------------------

type
  TSetOnConnect = procedure(Event: TOnConnect) of object; register;
  TSetOnDisconnect = procedure(Event: TOnDisconnect) of object; register;
  TSetOnBadLogin = procedure(Event: TOnBadLogin) of object; register;
  TSetOnConnecting = procedure(Event: TOnConnecting) of object; register;

//------------------------------------------------------------------------------
// Inne
//------------------------------------------------------------------------------

type
  TPluginSetNote = procedure(Tekst: ShortString); stdcall;

implementation

end.
